/************************************************************************
 *   IRC - Internet Relay Chat, include/msg.h
 *   Copyright (C) 1990 Jarkko Oikarinen and
 *                      University of Oulu, Computing Center
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/* $Id: msg.h,v 1.16.2.2 2004/07/30 01:31:18 tux316 Exp $ */

#ifndef	__msg_include__
#define __msg_include__

#define MSG_PRIVATE  "PRIVMSG"		/* PRIV */
#define MSG_WHO      "WHO"	      	/* WHO  -> WHOC */
#define MSG_WHOIS    "WHOIS"	   	/* WHOI */
#define MSG_WHOWAS   "WHOWAS"	   	/* WHOW */
#define MSG_USER     "USER"	   	/* USER */
#define MSG_NICK     "NICK"	   	/* NICK */
#define MSG_SERVER   "SERVER"	   	/* SERV */
#define MSG_LIST     "LIST"	   	/* LIST */
#define MSG_TOPIC    "TOPIC"	   	/* TOPI */
#define MSG_INVITE   "INVITE"	   	/* INVI */
#define MSG_VERSION  "VERSION"		/* VERS */
#define MSG_QUIT     "QUIT"	   	/* QUIT */
#define MSG_SQUIT    "SQUIT"	   	/* SQUI */
#define MSG_KILL     "KILL"	   	/* KILL */
#define MSG_INFO     "INFO"	   	/* INFO */
#define MSG_LINKS    "LINKS"	   	/* LINK */
#define MSG_STATS    "STATS"	   	/* STAT */
#define MSG_USERS    "USERS"	   	/* USER -> USRS */
#define MSG_HELP     "HELP"	   	/* HELP */
#define MSG_ERROR    "ERROR"	   	/* ERRO */
#define MSG_AWAY     "AWAY"	   	/* AWAY */
#define MSG_CONNECT  "CONNECT"		/* CONN */
#define MSG_PING     "PING"	   	/* PING */
#define MSG_PONG     "PONG"	   	/* PONG */
#define MSG_OPER     "OPER"	   	/* OPER */
#define MSG_PASS     "PASS"	   	/* PASS */
#define MSG_WALLOPS  "WALLOPS"		/* WALL */
#define MSG_TIME     "TIME"	   	/* TIME */
#define MSG_NAMES    "NAMES"	   	/* NAME */
#define MSG_ADMIN    "ADMIN"	   	/* ADMI */
#define MSG_TRACE    "TRACE"	   	/* TRAC */
#define MSG_NOTICE   "NOTICE"	   	/* NOTI */
#define MSG_JOIN     "JOIN"	   	/* JOIN */
#define MSG_PART     "PART"	   	/* PART */
#define MSG_LUSERS   "LUSERS"	   	/* LUSE */
#define MSG_MOTD     "MOTD"	   	/* MOTD */
#define MSG_MODE     "MODE"	   	/* MODE */
#define MSG_KICK     "KICK"	   	/* KICK */
#define MSG_USERHOST "USERHOST"		/* USER -> USRH */
#define MSG_ISON     "ISON"	   	/* ISON */
#define MSG_REHASH   "REHASH"	   	/* REHA */
#define MSG_RESTART  "RESTART"		/* REST */
#define MSG_CLOSE    "CLOSE"	   	/* CLOS */
#define MSG_SVINFO   "SVINFO"	   	/* SVINFO */
#define MSG_SJOIN    "SJOIN"	   	/* SJOIN */
#define MSG_DIE	     "DIE" 		/* DIE */
#define MSG_HASH     "HASH"	   	/* HASH */
#define MSG_DNS      "DNS"   	   	/* DNS  -> DNSS */
#define MSG_OPERWALL "OPERWALL"		/* OPERWALL */
#define MSG_GLOBOPS  "GLOBOPS"		/* GLOBOPS */
#define MSG_CHATOPS  "CHATOPS"		/* CHATOPS */
#define MSG_GOPER    "GOPER"	   	/* GOPER */
#define MSG_GNOTICE  "GNOTICE"		/* GNOTICE */
#define MSG_KLINE    "KLINE"	   	/* KLINE */
#define MSG_HTM      "HTM"	      	/* HTM */
#define MSG_SET      "SET"	      	/* SET */
#define MSG_SAMODE   "SAMODE"    	/* SAMODE */
#define MSG_CHANSERV "CHANSERV"		/* CHANSERV */
#define MSG_NICKSERV "NICKSERV"		/* NICKSERV */
#define MSG_MEMOSERV "MEMOSERV"		/* MEMOSERV */
#define MSG_ROOTSERV "ROOTSERV"		/* MEMOSERV */
#define MSG_OPERSERV "OPERSERV"		/* OPERSERV */
#define MSG_STATSERV "STATSERV" 	/* STATSERV */
#define MSG_HELPSERV "HELPSERV" 	/* HELPSERV */
#define MSG_SERVICES "SERVICES"		/* SERVICES */
#define MSG_IDENTIFY "IDENTIFY"		/* IDENTIFY */
#define MSG_CAPAB    "CAPAB"	   	/* CAPAB */ 
#define MSG_LOCOPS   "LOCOPS"	   	/* LOCOPS */
#define MSG_SVSNICK  "SVSNICK"   	/* SVSNICK */
#define MSG_SVSNOOP  "SVSNOOP"   	/* SVSNOOP */
#define MSG_SVSKILL  "SVSKILL"   	/* SVSKILL */
#define MSG_SVSMODE  "SVSMODE"   	/* SVSMODE */
#define MSG_AKILL    "AKILL"     	/* AKILL */
#define MSG_RAKILL   "RAKILL"    	/* RAKILL */
#define MSG_SILENCE  "SILENCE"   	/* SILENCE */
#define MSG_WATCH    "WATCH"     	/* WATCH */
#define MSG_SQLINE   "SQLINE" 		/* SQLINE */
#define MSG_UNSQLINE "UNSQLINE" 	/* UNSQLINE */
#define MSG_BURST    "BURST"     	/* BURST */
#define MSG_SGLINE   "SGLINE"		/* sgline */
#define MSG_UNSGLINE "UNSGLINE"		/* unsgline */
#define MSG_DKEY     "DKEY"			/* diffie-hellman negotiation */
#define MSG_NS	     "NS"            	/* NickServ commands */
#define MSG_CS	     "CS"            	/* ChanServ commands */
#define MSG_MS	     "MS"            	/* MemoServ commands */
#define MSG_RS	     "RS"            	/* RootServ commands */
#define MSG_OS	     "OS"            	/* OperServ commands */
#define MSG_SS	     "SS"            	/* StatServ commands */
#define MSG_HS	     "HS"            	/* StatServ commands */
#define MSG_GLINE	"GLINE"				/* gline */
#define MSG_UNGLINE	"UNGLINE"			/* ungline */
#define MSG_SHUN     "SHUN"		/* shun */
#define MSG_UNSHUN	"UNSHUN"	/* unshun*/
#define MSG_SVHOST   "SVHOST"		/* svhost */
#define MSG_SETHOST  "SETHOST"		/* sethost */
#define MSG_MAP	     "MAP"		/* map */
#define MSG_CONOPS	"CONOPS" /* conops */
#define MSG_UNKLINE  "UNKLINE"		/* UNKLINE */
#define MSG_DALINFO     "DALINFO"	   	/* DALINFO */

#ifdef ELMER
# define MSG_ELMER    "ELMER"		/* elmer */
#endif

#ifdef SILLY
# define MSG_SILLY    "SILLY"		/* silly */
#endif

#if defined(ELMER) || defined(SILLY)
# define MSG_NORMAL   "NORMAL"		/* normal */
#endif

#ifdef DCCALLOW
#define MSG_DCCALLOW "DCCALLOW"         /* dccallow */
#endif

#define TOK_NULL			"NUL"

#define MAXPARA      15

extern int m_kline(), m_unkline(), m_akill(), m_rakill(), m_kick();
extern int m_locops(), m_private(), m_topic(), m_join(), m_nick();
extern int m_part(), m_mode(), m_ping(), m_pong(), m_wallops();
extern int m_error(), m_notice(), m_invite(), m_quit(), m_kill();
extern int m_motd(), m_who(), m_whois(), m_user(), m_list();
extern int m_server(), m_info(), m_dalinfo(), m_links(), m_summon(), m_stats();
extern int m_users(), m_services(), m_identify(), m_ns(), m_cs();
extern int m_ms(), m_rs(), m_os(), m_ss(), m_hs(), m_svsnick();
extern int m_svsnoop(), m_svskill(), m_svsmode(), m_version();
extern int m_help(), m_squit(), m_away(), m_connect(), m_oper();
extern int m_pass(), m_trace(), m_time(), m_names(), m_admin();
extern int m_lusers(), m_umode(), m_close(), m_motd(), m_whowas();
extern int m_userhost(), m_ison(), m_svinfo(), m_sjoin(), m_samode();
extern int m_globops(), m_chatops(), m_goper(), m_gnotice(), m_rehash();
extern int m_restart(), m_die(), m_hash(), m_dns(), m_htm(), m_set();
extern int m_capab(), m_silence(), m_watch(), m_sqline(), m_unsqline();
extern int m_burst(), m_sgline(), m_unsgline(), m_dkey();
extern int m_shun(), m_unshun(), m_gline(), m_ungline(), m_svhost();
extern int m_map(), m_conops(), m_sethost();

#ifdef ELMER
extern int m_elmer();
#endif

#ifdef SILLY
extern int m_silly();
#endif

#if defined(ELMER) || defined(SILLY)
extern int m_normal();
#endif

#ifdef DCCALLOW
extern int m_dccallow()
#endif

#ifdef MSGTAB
struct Message msgtab[] = 
{
    {MSG_PRIVATE, m_private, 0, MAXPARA, 1, 0, 1,  0L},
    {MSG_NICK, m_nick, 0, MAXPARA, 1, 1, 0,  0L},
    {MSG_NOTICE, m_notice, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_JOIN, m_join, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_MODE, m_mode, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_SAMODE, m_samode, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_QUIT, m_quit, 0, MAXPARA, 1, 1, 0,  0L},
    {MSG_PART, m_part, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_TOPIC, m_topic, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_INVITE, m_invite, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_KICK, m_kick, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_WALLOPS, m_wallops, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_LOCOPS, m_locops, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_PONG, m_pong, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_PING, m_ping, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_ERROR, m_error, 0, MAXPARA, 1, 1, 0,  0L},
    {MSG_KILL, m_kill, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_USER, m_user, 0, MAXPARA, 1, 1, 0,  0L},
    {MSG_AWAY, m_away, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_ISON, m_ison, 0, 1, 1, 0, 0,  0L},
    {MSG_SERVER, m_server, 0, MAXPARA, 1, 1, 0,  0L},
    {MSG_SQUIT, m_squit, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_WHOIS, m_whois, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_WHO, m_who, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_WHOWAS, m_whowas, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_LIST, m_list, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_NAMES, m_names, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_USERHOST, m_userhost, 0, 1, 1, 0, 0,  0L},
    {MSG_TRACE, m_trace, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_PASS, m_pass, 0, MAXPARA, 1, 1, 0,  0L},
    {MSG_LUSERS, m_lusers, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_TIME, m_time, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_OPER, m_oper, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_CONNECT, m_connect, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_VERSION, m_version, 0, MAXPARA, 1, 1, 0,  0L},
    {MSG_STATS, m_stats, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_LINKS, m_links, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_ADMIN, m_admin, 0, MAXPARA, 1, 1, 0,  0L},
    {MSG_USERS, m_users, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_HELP, m_help, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_INFO, m_info, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_MOTD, m_motd, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_SVINFO, m_svinfo, 0, MAXPARA, 1, 1, 0,  0L},
    {MSG_SJOIN, m_sjoin, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_GLOBOPS, m_globops, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_CHATOPS, m_chatops, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_GOPER, m_goper, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_GNOTICE, m_gnotice, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_CLOSE, m_close, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_KLINE, m_kline, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_UNKLINE, m_unkline, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_HASH, m_hash, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_DNS, m_dns, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_REHASH, m_rehash, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_RESTART, m_restart, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_DIE, m_die, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_HTM, m_htm, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_SET, m_set, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_CHANSERV, m_cs, 0, 1, 1, 0, 0,  0L},
    {MSG_NICKSERV, m_ns, 0, 1, 1, 0, 0,  0L},
    {MSG_MEMOSERV, m_ms, 0, 1, 1, 0, 0,  0L},
    {MSG_ROOTSERV, m_rs, 0, 1, 1, 0, 0,  0L},
    {MSG_OPERSERV, m_os, 0, 1, 1, 0, 0,  0L},
    {MSG_STATSERV, m_ss, 0, 1, 1, 0, 0,  0L},
    {MSG_HELPSERV, m_hs, 0, 1, 1, 0, 0,  0L},
    {MSG_SERVICES, m_services, 0, 1, 1, 0, 0,  0L},
    {MSG_IDENTIFY, m_identify, 0, 1, 1, 0, 0,  0L},
    {MSG_SVSNICK,  m_svsnick,  0, MAXPARA, 1, 0, 0,  0L},
    {MSG_SVSNOOP,  m_svsnoop,  0, MAXPARA, 1, 0, 0,  0L},
    {MSG_SVSKILL,  m_svskill,  0, MAXPARA, 1, 0, 0,  0L},	 
    {MSG_SVSMODE,  m_svsmode,  0, MAXPARA, 1, 0, 0,  0L},	 
    {MSG_AKILL,    m_akill,    0, MAXPARA, 1, 0, 0,  0L},
    {MSG_RAKILL,   m_rakill,   0, MAXPARA, 1, 0, 0,  0L}, 
    {MSG_SILENCE,  m_silence,  0, MAXPARA, 1, 0, 0,  0L },
    {MSG_WATCH, m_watch, 0, 1, 1, 0, 0,  0L },
    {MSG_SQLINE, m_sqline, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_UNSQLINE, m_unsqline, 0, MAXPARA, 1, 0, 0,  0L },
    {MSG_CAPAB, m_capab, 0, MAXPARA, 1, 1, 0,  0L},
    {MSG_BURST, m_burst, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_SGLINE, m_sgline, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_UNSGLINE, m_unsgline, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_DKEY, m_dkey, 0, MAXPARA, 1, 1, 0,  0L},
    {MSG_NS, m_ns, 0, 1, 1, 1, 0,  0L},
    {MSG_CS, m_cs, 0, 1, 1, 1, 0,  0L},
    {MSG_MS, m_ms, 0, 1, 1, 1, 0,  0L},
    {MSG_RS, m_rs, 0, 1, 1, 1, 0,  0L},
    {MSG_OS, m_os, 0, 1, 1, 1, 0,  0L},
    {MSG_SS, m_ss, 0, 1, 1, 1, 0,  0L},
    {MSG_HS, m_hs, 0, 1, 1, 1, 0,  0L},
    {MSG_SHUN, m_shun, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_UNSHUN, m_unshun, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_GLINE, m_gline, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_UNGLINE, m_ungline, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_SVHOST, m_svhost, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_SETHOST, m_sethost, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_MAP, m_map, 0, MAXPARA, 1, 0, 0,  0L},
    {MSG_CONOPS, m_conops, 0, MAXPARA, 1, 0, 0,  0L},
	{MSG_DALINFO, m_dalinfo, 0, MAXPARA, 1, 0, 0,  0L},
#ifdef ELMER
    {MSG_ELMER, m_elmer, 0, MAXPARA, 1, 0, 0,  0L},
#endif
#ifdef SILLY
    {MSG_SILLY, m_silly, 0, MAXPARA, 1, 0, 0,  0L},
#endif
#if defined(SILLY) || defined(ELMER)
    {MSG_NORMAL, m_normal, 0, MAXPARA, 1, 0, 0,  0L},
#endif
#ifdef DCCALLOW
    {MSG_DCCALLOW, m_dccallow, 0, 1, 1, 0, 0,  0L },
#endif
    {(char *) 0, (int (*)()) 0, 0, 0, 0, 0, 0,  0L}
};

MESSAGE_TREE *msg_tree_root;
#else
extern struct Message msgtab[];
extern MESSAGE_TREE *msg_tree_root;
#endif
#endif /* __msg_include__  */
