/*
 * Solid Internet Relay Chat daemon, src/send.c
 * Copyright (C) 1999 VidGameChat.Net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/* $Id: silly.c,v 1.7.2.1 2004/07/22 17:24:39 tux316 Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define STATES_NUM 512
#undef CHECK

typedef struct {
	short next_state[128];
	char *replacement;
} STATE;
static STATE state[STATES_NUM];
static int next_free_state;

/*****************************************
* Start whee routines
*****************************************/

char *add_punctuation(char *old_msg, char *new_msg)
{
        int i, len;

        len = strlen(new_msg);

        for (i=0; old_msg[i]; i++) {

                switch(old_msg[i]) {

                        case '!':
                        case '?':
                        case '.':
                                new_msg[len++] = old_msg[i];
                                new_msg[len] = 0;
                                if (len == 256)
                                        break;
                }
        }
        return new_msg;
}

/*****************************************
* End whee routines
*****************************************/

/*****************************************
* Start ELMER routines
*****************************************/

void add_translate(char *old_text, char *new_text)
{
	int i, len, curr_state, curr_char;
	short *next_state_p;

	len = strlen(old_text);
	curr_state = 0;

	for (i=0; i<len; i++) {

		curr_char = old_text[i];
		next_state_p = &state[curr_state].next_state[curr_char];

		if (*next_state_p)
			curr_state = *next_state_p;
		else
			*next_state_p = curr_state = next_free_state++;
	}

	state[curr_state].replacement = new_text;
}

void init_chef(void)
{
	memset(state, 0, sizeof(state));
	next_free_state = 1;

	/* Basic rules */
	add_translate("r",   "w");
	add_translate("l",   "w");
	add_translate("L",   "W");
	add_translate("qu",  "qw");
	add_translate("th ", "f ");
	add_translate("th",  "d");
	add_translate("n.",  "n, uh-hah-hah-hah.");
	add_translate("N.",  "N, uh-hah-hah-hah.");

	/* Advanced rules */
	add_translate("cr",     "kw");
	add_translate("chr",    "kw");
	add_translate(" laugh", " waff");

	/* IRC shorthand */
	add_translate("lmao",   "waffing my postewiow off!");
	add_translate("lol",    "uh-hah-hah-hah!");
	add_translate("LoL",    "UH-HAH-HAH-HAH!");
	add_translate("rofl",   "uh-hah-hah-hah!");
	add_translate("wtf",     "huh");
	add_translate("WTF",     "HUH???");

	add_translate(" ass",    " wabbit postewiow");
	add_translate(" a$$",    " wabbit postewiow");
	add_translate("biatch",  "wabbit giww");
	add_translate("biotch",  "wabbit giww");
	add_translate("bitch",   "wabbit giww");
	add_translate("bitches", "wabbit giwws");
	add_translate("butt",    "wabbit postewiow");
	add_translate("cock",    "wabbit thingie");
	add_translate("crap",    "wabbit poop");
	add_translate("cum",     "wabbit stuff");
	add_translate("cunt",    "wabbit thingie");
	add_translate("damn",    "scwewy wabbit");
	add_translate("dick",    "wabbit thingie");
	add_translate("fag",     "dawn wabbit");
	add_translate("faget",   "dawn wabbit");
	add_translate("fagget",  "dawn wabbit");
	add_translate("faggot",  "dawn wabbit");
	add_translate("feces",   "wabbit poop");
	add_translate("fuck",    "wabbit poop");
	add_translate("FUCK",    "wabbit poop");
	add_translate("fuk",     "wabbit poop");
	add_translate("FUK",     "wabbit poop");
	add_translate("gay",     "happy");
	add_translate("gook",    "dawn wabbit");
	add_translate(" hell",  " deep wabbit howe");
	add_translate(" hoe",    " scwewy wabbit");
	add_translate("idiot",   "scwewy wabbit");
	add_translate("jap ",    "dawn wabbit ");
	add_translate("jerk",    "scwewy wabbit");
	add_translate("jew ",    "dawn wabbit ");
	add_translate("kill",    "hunt");
	add_translate("kike",    "dawn wabbit");
	add_translate("loser",   "scwewy wabbit");
	add_translate("moron",   "scwewy wabbit");
	add_translate("nigga",   "dawn wabbit");
	add_translate("nigger",  "dawn wabbit");
	add_translate("penis",   "wabbit thingie");
	add_translate("person",  "scwewy wabbit");
	add_translate("picture", "pictuwe");
	add_translate("pimp",    "scwewy wabbit");
	add_translate("pissed",  "vewy mad");
	add_translate("PISSED",  "SO VEWY MAD");
	add_translate("pissed off", "so vewy mad");
	add_translate("pist",    "vewy mad");
	add_translate("pist off", "so vewy mad");
	add_translate("porn",    "nekkid wabbit pictuwe");
	add_translate("pron",    "nekkid wabbit pictuwe");
	add_translate("pr0n",    "nekkid wabbit pictuwe");
	add_translate("p0rn",    "nekkid wabbit pictuwe");
	add_translate("pussy",   "wabbit thingie");
	add_translate("slut",    "cwazy wabbit");
	add_translate("shit",    "wabbit poop");
	add_translate("SHIT",    "WABBIT POOP");
	add_translate("stupid",  "scwewy wabbit");
	add_translate("shut up", "be vewy qwiet");
	add_translate("SHUT UP", "BE VEWY, VEWY QWIET");
	add_translate("shutup",  "be vewy qwiet");
	add_translate("SHUTUP",  "BE VEWY, VEWY QWIET");
	add_translate("twat",    "wabbit thingie");
	add_translate("vagina",  "wabbit thingie");
	add_translate("whore",   "wabbit");

	add_translate("segarules",   "cwazy wabbits sewvew");
	add_translate("freedomchat", "cwazy wabbits sewvew");
	add_translate("irc.segarules.com", "scwewy wabbits sewvew");
	add_translate("irc.freedomchat.net", "scwewy wabbits sewvew");
	add_translate("leo",       "scwewy wabbit");
	add_translate("Leo",       "scwewy wabbit");
	add_translate("leorules",  "scwewy wabbit");
	add_translate("Leorules",  "scwewy wabbit");
	add_translate("waro",      "cwazy wabbit");
	add_translate("Waro",      "cwazy wabbit");
	add_translate("warp",      "cwazy wabbit");
	add_translate("Warp",      "cwazy wabbit");
	add_translate("wartoyz",   "cwazy wabbit");
	add_translate("Wartoyz",   "cwazy wabbit");
#ifdef CHECK
	printf("states used: %d\n", next_free_state);
#endif
}

void encode_chef(char *old_text, char *new_text, int chars_left)

{
        char *old_frag, *last_replacement, *add_frag, *temp;
        int curr_state, old_frag_len, add_frag_len;
		int last_replacement_len=0;

        chars_left--;   /* Leave space for null terminator */

        temp = new_text;

        do {
                old_frag     = old_text;
                old_frag_len = 0;
                curr_state   = 0;
                last_replacement = 0;

                do {
                        curr_state = state[curr_state].next_state[*old_frag++ & 0x7f];
                        old_frag_len++;

                        if (state[curr_state].replacement) {
                                last_replacement = state[curr_state].replacement;
                                last_replacement_len = old_frag_len;
                        }

                } while (curr_state);

                if (last_replacement) {
                        add_frag = last_replacement;
                        add_frag_len = strlen(last_replacement);
                        old_text += last_replacement_len;
                } else {
                        add_frag = old_text++;
                        add_frag_len = 1;
                }

                if (add_frag_len > chars_left)
                        add_frag_len = chars_left;

                strncpy(new_text, add_frag, add_frag_len);
                new_text   += add_frag_len;
                chars_left -= add_frag_len;

                if (!chars_left)
                        break;

        } while (*old_text);

        *new_text = 0;
}

/*****************************************
* End ELMER routines
*****************************************/
#ifdef CHECK
void main(void) {
	char buffer[256], buffer2[256];
	init_chef();
	printf("Text: ");
	gets(buffer);
	encode_chef(buffer, buffer2, 256);	
	printf("Translation: %s\n",buffer2);
}
#endif

